/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.ergebniskonflikt.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.ergebniskonflikt.entity.ErgebnisKonflikt;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractErgebnisKonfliktSearch {

  @Inject
  protected transient ErgebnisKonfliktExtendedDAO dao;

  public AbstractErgebnisKonfliktSearch() {
    super();
  }

  public List<ErgebnisKonflikt> getSearchResult(ErgebnisKonfliktSearchParameters searchParameters, EagerLoadingCollector<ErgebnisKonflikt> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<ErgebnisKonflikt> querySearchResult(ErgebnisKonfliktSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
